#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>

#define KB 1024
#define MB 1024 * KB
#define GB 1024 * MB
#define SIZE_OF_MEMORY 839*MB   // Main memory size
#define CPU_FREQ 900000.0
#define ITERATIONS 1024.0*1024.0
#define handle_error(msg) do { perror(msg); exit(EXIT_FAILURE); } while (0)


int main(int argc, char *argv[]){

    int fd1, fd2;
    char *addr1, *addr2;
    register volatile int c=0;
    int i, j;
    unsigned s_t, e_t, t=0;
    
    if (argc != 3){
        printf("usage: a.out <file1> <file2> \n");
        exit(EXIT_FAILURE);
    }

    if ((fd1 = open(argv[1], O_RDONLY)) == -1){
        //handle_error("open");
	printf("exit fd1\n");
	exit(0);
    }

    if ((fd2 = open(argv[2], O_RDONLY)) == -1){
        //handle_error("open");
	printf("exit fd2\n");
	exit(0);
    }

    posix_fadvise(fd1, 0, 0, POSIX_FADV_RANDOM);
    posix_fadvise(fd2, 0, 0, POSIX_FADV_RANDOM);

    addr1 = (char *) mmap(0, SIZE_OF_MEMORY, PROT_READ, MAP_PRIVATE | MAP_POPULATE, fd1, 0);
    if (addr1 == MAP_FAILED){
        printf("mmap1 %d %s", errno, strerror(errno));
	exit(0);
    }
    addr2 = (char *) mmap(0, SIZE_OF_MEMORY, PROT_READ, MAP_PRIVATE | MAP_POPULATE, fd2, 0);
    if (addr2 == MAP_FAILED){
        printf("mmap2 %d %s", errno, strerror(errno));
	exit(0);
    }

    madvise(addr1, 0, MADV_RANDOM);
    madvise(addr2, 0, MADV_RANDOM);
	asm volatile("mrc p15, 0, %0, c9, c14, 0" : "=r" (i));
	printf("User enable regr: %x\n", i);
 
    j = 32;
    for(i = 0; i < 10; i++){
	    asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (s_t));
	    c+= (addr1[i*30*MB]);      // read at multiple of page size, so every read causes a page fault
	    //c+= (addr1[i*MB]);      // read at multiple of page size, so every read causes a page fault
	//	j = j*2;
	    //c = c+1;
	    asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (e_t));
	    t += (e_t - s_t);
	    printf("Time required to service a page faut is %u %u %u \n",e_t, s_t, (e_t-s_t));
	    fflush(NULL);
    }
    printf("\nAverage time required to service a page fault is %u \n", t);
    
    munmap(addr1, SIZE_OF_MEMORY);
    munmap(addr2, SIZE_OF_MEMORY);
    
    return 0;
}

