#include<stdio.h>
#include <sys/time.h>
#include <stdlib.h>

#define KB 1024
#define MB 1024 * KB
#define MAX_ARRAY_SIZE 32*MB
#define STRIDE_SIZE 16
#define CPU_FREQ 900

typedef unsigned long long int u64;

u64 access_time_1(u64 size, int stride_size){
	struct timeval start, end;
	struct timezone tz;

    int *array = (int *)malloc(size);
    int len = (size)/sizeof(int);
    unsigned int i;

	gettimeofday(&start, &tz);
   	for(i=0; i < MAX_ARRAY_SIZE; i++) {
       array[( i * stride_size) % len]++;
    }
	gettimeofday(&end, &tz);
   
    free(array);
	return ((end.tv_sec * 1e6) + end.tv_usec - (start.tv_sec * 1e6) - start.tv_usec);
}
 
int main()
{
	int i, j;

	for (j = 4; j <= 256; j*=2) {
		printf("Stride size: %u\n", j);
		for (i = 1024; i <= 32 * MB; i*=2) {
			u64 access_time = access_time_1(i, j);
			u64 overhead = 10;
			double avg = (access_time * 1000.0)/(2 * MAX_ARRAY_SIZE);
			printf("Size: %uKB access: %lluus, avg: %gns\n", i >> 10, access_time, avg - overhead);
		}
	}
	return 0;
}
