#include "../rasperf.h"
#include<stdio.h>
#include<stdlib.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netdb.h>
#include<string.h>
//Macro definitions
#define handle_error(msg) \
    do { perror(msg); exit(1);} while(0);
#define BACKLOG 50
int main(int argc, char*argv[])
{   
    int socket_fd, rc;
    float start_delta = 0, close_delta = 0;
    if(argc<2){
        handle_error("<usage>:tcp_client <IP address>");
    }
    //Retrieve the protocol number mapping 
    //from /etc/protocols file
    struct protoent *proto_entry;
    proto_entry = getprotobyname("tcp");
    

    //My address information to bind to
    struct sockaddr_in server;
    memset(&server, 0, sizeof(struct sockaddr));
    server.sin_family = AF_INET;
    server.sin_port = htons(8000);
    
    rc= inet_pton(AF_INET, argv[1], &server.sin_addr);
    if(rc == -1){
        handle_error("Address Error");
    }
    time starttime, endtime;
    //accept incoming connections
    int addr_size = sizeof(struct sockaddr);
    int i;
    int protonum = proto_entry->p_proto;
    for(i=1;i<=BACKLOG;i++){
         //Open an socket end-point for this TCP Server
        if((socket_fd = socket(AF_INET, SOCK_STREAM, protonum))<0){
            handle_error("Socket Error");
        }
        getTime(starttime);
        if(connect(socket_fd, (struct sockaddr*)&server, sizeof(server))<0){
            handle_error("Connection Error");
        }
        /*The end calculated here will miss time taken for ACK K+1 
        from the client. And so we have to one way delay
        measured using another experiment*/
        getTime(endtime);

        //Calculate connection overhead client
        start_delta+=diff(endtime,starttime);
        int z;  /* Status code */
        int s;     /* Socket s */
        struct linger so_linger;

        so_linger.l_onoff = 1;
        so_linger.l_linger = 0;
        z = setsockopt(socket_fd,
            SOL_SOCKET,
            SO_LINGER,
            &so_linger,
            sizeof so_linger);

        if ( z )
            perror("setsockopt(2)");
        
        getTime(starttime);
        close(socket_fd);
        getTime(endtime);
        
        //Calculate connection overhead server side
        close_delta+=diff(endtime,starttime);
    }
    printf("Connection Setup =%f us\n", (start_delta + RTT/2 * BACKLOG)/BACKLOG);
    printf("Connection Teardown =%f us\n", (close_delta + RTT/2 * BACKLOG)/BACKLOG);
    return 0;
}
   
 
