#include "../rasperf.h"
#include<stdio.h>
#include<stdlib.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netdb.h>
#include<string.h>
//Macro definitions
#define handle_error(msg) \
    do { perror(msg); exit(1);} while(0);
#define BUFFER_SIZE 1 * MB
#define MB 1024 * 1024
#define STRIDE_SIZE 64
#define BACKLOG 64 //buff size/stride size

//A random string generator of given length
char* generate_string(int length)
{
    //Random number seed
    srand((unsigned int) ctime(0));
    char * buff;
    buff=(char *)malloc(sizeof(char)*(length+1));
    int i;
    for(i=0;i< length;i++){
        buff[i] = rand() % rand() % (126 - 33 + 1) + 33;
    }
    buff[i] = '\0';
    return buff;
}

int main(int argc, char*argv[])
{   
    int socket_fd, rc;
    char buff[BUFFER_SIZE];
    char *msg;
    float delta = 0, min =9999;
    if(argc<2){
        handle_error("<usage>:tcp_client <IP address>");
    }
    //Retrieve the protocol number mapping 
    //from /etc/protocols file
    struct protoent *proto_entry;
    proto_entry = getprotobyname("tcp");
    

    //My address information to bind to
    struct sockaddr_in server;
    memset(&server, 0, sizeof(struct sockaddr));
    server.sin_family = AF_INET;
    server.sin_port = htons(9);
    
    rc= inet_pton(AF_INET, argv[1], &server.sin_addr);
    if(rc == -1){
        handle_error("Address Error");
    }
    time starttime, endtime;
    //accept incoming connections
    int addr_size = sizeof(struct sockaddr);
    int i;
    int protonum = proto_entry->p_proto;
    
    //Open an socket end-point for this TCP Server
    if((socket_fd = socket(AF_INET, SOCK_STREAM, protonum))<0){
        handle_error("Socket Error");
    }
    if(connect(socket_fd, (struct sockaddr*)&server, sizeof(server))<0){
        handle_error("Connection Error");
    }
    msg = generate_string(BUFFER_SIZE);
    for(i=1;i<=BACKLOG;i++){
        getTime(starttime);
        if(send(socket_fd, msg, strlen(msg), 0) <0){
            handle_error("Send Error");
        }
        getTime(endtime);
        delta+=(diff(endtime, starttime));
        if(delta < min) min = delta;
        printf("Single Tput %fBps\n",(BUFFER_SIZE/ diff(endtime, starttime)));
    }
    
    close(socket_fd);
    printf("GoodPut = %f Bps, MaxTput= %f Bps", (BUFFER_SIZE)*(BACKLOG/delta), (BUFFER_SIZE/min));
    return 0;
}
   
 
